<template>
  <div class="agent-info" v-if="agent">

    <div class="agent-info__header" v-if="groups.length">
      <div class="agent-info__groups">
        <span>Входит в группы:</span>
        <div class="agent-info__chips">
          <div class="agent-info__chip"
            v-for="group in groups"
            :key="group.uuid"
          >
            {{group.title}}
          </div>
        </div>
      </div>
    </div>

    <div class="agent-info__table">
      <div class="agent-info__table-row agent-info__table-row--header">
        <div class="agent-table__col-left">
          наименование поля
        </div>
        <div class="agent-table__col-right">
          значение поля
        </div>
      </div>

      <div class="agent-info__table-block" v-for="block in agent.groups" :key="block.requisiteGroupUuid">
        <div class="agent-info__table-row agent-info__table-row--expandable" @click="toggleExpand(block.requisiteGroupUuid)">
          <div class="agent-table__col-left">
            <button data-qa="btnIndicators" :class="{ closed: !expands[`${block.requisiteGroupUuid}Expanded`] }">
              <i class="icon chevron-up"></i>
            </button>
            <span>{{ block.requisiteGroupTitle }}</span>
          </div>
        </div>
        <expand-transition scrollIntoView>
          <div v-if="expands[`${block.requisiteGroupUuid}Expanded`]">
            <div class="agent-info__table-row" v-for="row in block.fields" :key="row.fieldUuid">
              <div class="agent-table__col-left">
                <span>{{ row.fieldPos }}</span>
                {{ row.fieldTitle }}
              </div>
              <div v-if="row.fieldValues.length" class="agent-table__col-right" v-html="getRowValue(row.fieldValues[0].data.value)">
              </div>
            </div>
          </div>
        </expand-transition>
      </div>

    </div>
  </div>
</template>

<script>
import expandTransition from '../../../components/ExpandTransition';

  export default {
    name: 'agentCardComponent',

    props: {
      agent: {
        type: Object
      },

      uuid: {
        type: String
      },

      groups: {
        type: Array
      }
    },

    riskColorsMap: {
      'GREEN': 'risk-1-blue',
      'BLUE': 'risk-2-green',
      'YELLOW': 'risk-3-yellow',
      'ORANGE': 'risk-4-orange',
      'RED': 'risk-5-red',
      'BLACK': 'risk-6-black'
    },

    rolesMap: {
      CLICAR: 'Заказчик-Исполнитель',
      CARRIER: 'Исполнитель',
      CLIENT: 'Заказчик'
    },

    components: {
      expandTransition,
    },

    data() {
      return {
        expands: {}
      }
    },

    created() {
      for (let i of this.agent.groups) {
        this.$set(this.expands, `${i.requisiteGroupUuid}Expanded`, true);
      }
    },

    methods: {
      toggleExpand(key) {
        this.expands[`${key}Expanded`] = !this.expands[`${key}Expanded`];
      },

      getRowValue(val) {
        if (val === true || val === 'true') {
          return "Да";
        }
        if (val === false || val === 'false') {
          return "Нет";
        }
        return val;
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.agent-info__groups {
  display: flex;

  span {
    position: relative;
    top: 4px;
    margin-right: 15px;
    color: $gray-slate;
  }
}

.agent-info__chips {
  display: flex;
  flex-wrap: wrap;
  position: relative;
  color: $color-text-base;
}

.agent-info__chip {
  padding: 7px 12px;
  margin-right: 10px;
  margin-bottom: 10px;
  border-radius: 10px;
  background-color: #EAF5FA;
  line-height: 1;
}

.agent-info__table {
  margin-top: 30px;
  margin-left: -25px;
  margin-right: -25px;

  button {
    margin-right: 8px;
    border: none;
    outline: none;
    background-color: transparent;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    font-size: 16px;
    color: $color-blue-navy-blue;
    -webkit-transition: all 0.2s ease-in-out;
    transition: all 0.2s ease-in-out;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);

    .chevron-up {
      display: inline-block;
      transform: rotate(180deg);
    }
  }

  .closed .chevron-up {
    transform: rotate(90deg);
  }
}

.agent-info__table-row {
  display: flex;
  @include font-mixin(14px, 20px, 400, $color-text-base, 0.2px);
  border-bottom: 1px solid $lavender;

  &--header {
    @include font-mixin(11px, 12px, 400, $shale-gray, 0.4px, uppercase);
  }

  &--expandable {
    color: $color-blue-navy-blue;
    cursor: pointer;

    .agent-table__col-left {
      padding-left: 15px;
    }    
  }
}

.agent-table__col-left {
  width: 350px;
  min-height: 40px;
  display: flex;
  align-items: center;
  padding-left: 40px;
  padding-top: 10px;
  padding-bottom: 10px;

  span {
    margin-right: 25px;
    min-width: 16px;
  }
}

.agent-table__col-right {
  flex-grow: 1;
  min-height: 40px;
  display: flex;
  align-items: center;
  padding-top: 10px;
  padding-bottom: 10px;
}

::v-deep {
  .agent-info__table-advs {
    display: flex;
  }

  .agent-info__table-adv {
    display: flex;
    align-items: center;
    color: $color-blue-navy-blue;

    &:not(:last-child) {
      margin-right: 10px;
    }
  }

  .agent-info__table-chips {
    display: flex;
    align-items: center;
    flex-wrap: wrap;
    position: relative;
    color: $color-text-base;
  }

  .agent-info__table-chip {
    padding: 7px 12px;
    margin-right: 10px;
    margin-bottom: 10px;
    border-radius: 10px;
    background-color: #C1EBFF;
    line-height: 1;
  }
}

</style>